/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomStorage_H__
#define __GdomStorage_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomStorage GdomStorage;
typedef struct _GdomStorageClass GdomStorageClass;


#define GDOM_TYPE_STORAGE            (gdom_storage_get_type())
#define GDOM_STORAGE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_STORAGE, GdomStorage))
#define GDOM_STORAGE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_STORAGE, GdomStorage)Class)
#define GDOM_IS_STORAGE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_STORAGE))
#define GDOM_IS_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_STORAGE))
#define GDOM_STORAGE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_STORAGE, GdomStorageClass))

typedef struct _GdomStoragePrivate GdomStoragePrivate;

struct _GdomStorage {
    GdomDOMObject parent_instance;
    GdomStoragePrivate *priv;
};

struct _GdomStorageClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_storage_get_type (void);

WEBKIT_API gchar *
gdom_storage_key (GdomStorage *thiz, gulong index);

WEBKIT_API gchar *
gdom_storage_get_item (GdomStorage *thiz, gchar * key);

WEBKIT_API void
gdom_storage_set_item (GdomStorage *thiz, gchar * key, gchar * data);

WEBKIT_API void
gdom_storage_remove_item (GdomStorage *thiz, gchar * key);

WEBKIT_API void
gdom_storage_clear (GdomStorage *thiz);

G_END_DECLS

#endif /* __GdomStorage_H__ */
